
#ifndef CPU_NNLS_H_
#define CPU_NNLS_H_

//Comment out for single precision
#define USE_DOUBLE

#ifdef USE_DOUBLE
#define REAL double
#else
#define REAL float
#endif

//NNLS Constants
#define MAX_ITER_LS_CPU(m, n) (((m)+(n))*2)
#define MAX_ITER_NNLS_CPU(m, n)  MAX_ITER_LS_CPU(m, n)

////Utility macros
#ifndef MIN
#define MIN(a, b)	((a)>(b)?(b):(a))
#endif
#ifndef MAX
#define MAX(a, b)	((a)>(b)?(a):(b))
#endif
#ifndef SIGN
#define SIGN(a)		((a)>0?1:-1)
#endif


//Index macros
#define M2(i, j, jl) ((i) * (jl) + (j))
#define M3(i, j, k, jl, kl) ((i) * ((jl) * (kl)) + (j) * (kl) + (k) )

void nnlsOMPSysMKLUpdates(REAL *A, REAL *b, REAL *x, int isTransposed,
		int maxNNLSIters, int maxLSIters, int nSys, int m, int n, int MKLT,
		int OMPT, REAL TOL_TERMINATION);

#endif /* CPU_NNLS_H_ */
