
#ifndef ENNNLS_H_
#define ENNNLS_H_

#define IDX2C(i,j,colN) (((j)*(colN))+(i))
#define IDX3C(x,y,z,colN,rowN) (x + y*(colN) + z*(colN*rowN))
#define IDX4C(a,b,c,d,colN,rowN,ZN) (a + b*(colN) + c*(colN*rowN) + d*(colN*rowN*ZN))

#include "mkl.h"
#include "headers2.h"

// logarithmically spaced vector
void logspace(const float& d1, const float& d2, const int& n, float* T2_times);

// Linearly spaced vector
void linspace(const float& d1, const float& d2, const int& n, float* flip_angles);

void EPGdecaycurveMKL2(const int& ETL, const float& flip_angle, const float& TE, const float& T2,
		const float& T1, const float& refcon, float* echo_amp, MKL_Complex8* Tr_dia, int x, int numCPU);

void applyRelaxationMatrixMKL2(MKL_Complex8* MM, MKL_Complex8* Tr_dia, MKL_Complex8* T_p, float* echo_amp,
		const int& ETL, const float& TE, const float& T2, int x, int numCPU);

void relaxmat_mkl_preComputed(const int& ETL, const float& TE, const float& T2,
		const float& T1, MKL_Complex8* T_r, int angleInd);

void flipmat_mkl(const float& alpha, const int& num_pulses, const float& refcon, MKL_Complex8* T_1, MKL_Complex8* T_p);

void calculate_Tr_dia(MKL_Complex8* T_r, MKL_Complex8* Tr_dia, int x);

void MatrixMul_mkl(MKL_Complex8* C, MKL_Complex8* A, MKL_Complex8* B,
		unsigned int uiWA, unsigned int uiHA, unsigned int uiWB, unsigned int uiHB);

// solve Ax=b using regularization
void NNLSreg(REAL* h_A, REAL* h_b, REAL* h_x, const float& Chi2Factor, int numCPU);

void srNNLS(REAL* h_A, REAL* h_b, REAL* h_x, const float& Chi2Factor,
		REAL* priorT2, float reg_control, int numCPU);


#endif /* ENNNLS_H_ */
