#ifndef LIDARHEADERS_H
#define LIDARHEADERS_H

////////////////////////////////////////////////////////////////////////////////////
////GPU options
////////////////////////////////////////////////////////////////////////////////////

#define GRIDX_WIDTH			(MIN(256, NSYS))
#define conGRIDX_WIDTH		(MIN(256, conNSYS))

#define GPU_USE			0				//GPU device to use		//On local system, 0=gtx275, 1=gtx8800


////////////////////////////////////////////////////////////////////////////////////
////Linear systems options
////////////////////////////////////////////////////////////////////////////////////

#define NSYS		1			//Number of linear equation systems
#define conNSYS		8			//Number of linear equation systems (# of angles)
								//for concurrent NNLS execution

#define Nnnls		32			//Rows (number of equations)
#define Mnnls		40			//Cols (number of variables)

#define Nreg		72			//Rows (number of equations)
#define Mreg		40			//Cols (number of variables)

////////////////////////////////////////////////////////////////////////////////////
////NNLS options
////////////////////////////////////////////////////////////////////////////////////

#define MAX_ITER_LS				((Nnnls+Mnnls)*2)
#define MAX_ITER_NNLS			((Nnnls+Mnnls)*2)

#define TOL_TERMINATION			(1e-10)
#define TOL_0					(1e-6)


////////////////////////////////////////////////////////////////////////////////////
////Debug options
////////////////////////////////////////////////////////////////////////////////////

#define DAT_DEBUG				1
#define DAT_DEBUG_CHECKROW		(0-NSTART)


////////////////////////////////////////////////////////////////////////////////////
////Macros
////////////////////////////////////////////////////////////////////////////////////

//Utility macros
#ifndef MIN
#define MIN(a, b)	((a)>(b)?(b):(a))
#endif

#ifndef MAX
#define MAX(a, b)	((a)>(b)?(a):(b))
#endif

#ifndef SIGN
#define SIGN(a)		((a)>0?1:-1)
#endif

//Index macros
#define X_I(a, b)		((a)*(Mnnls)+(b))
#define B_I(a, b)		((a)*(Nnnls)+(b))
#define R_I(a, b, c)	((a)*((Mnnls)*(Mnnls))+(b)*(Mnnls)+(c))
#define A_I(a, b, c)	((a)*((Nnnls)*(Mnnls))+(b)*(Mnnls)+(c))
#define A_IT(a, b, c)	((a)*((Nnnls)*(Mnnls))+(b)*(Nnnls)+(c))

//Index macros
#define X_Ireg(a, b)		((a)*(Mreg)+(b))
#define B_Ireg(a, b)		((a)*(Nreg)+(b))
#define R_Ireg(a, b, c)	((a)*((Mreg)*(Mreg))+(b)*(Mreg)+(c))
#define A_Ireg(a, b, c)	((a)*((Nreg)*(Mreg))+(b)*(Mreg)+(c))
#define A_ITreg(a, b, c)	((a)*((Nreg)*(Mreg))+(b)*(Nreg)+(c))

#endif

